<?php

if (!empty($setmodules)) {
	$file = basename(__FILE__);
	$module['Invites']['Invites rules'] = $file.'?mode=rules';
	$module['Invites']['Invites history'] = $file.'?mode=history';
	return;
}

if (isset($_POST['mode']) || isset($_GET['mode'])) $mode = (isset($_POST['mode'])) ? $_POST['mode'] : $_GET['mode'];

require('./pagestart.php');

function get_myselect ($select_name, $selected_group)
{
	global $db;
	$select_ary = array();
	$sql = "SELECT group_id, group_name
		FROM ". GROUPS_TABLE ."
		WHERE group_single_user = 0
		ORDER BY group_name";
	$select_ary['----'] = '0';
	foreach ($db->fetch_rowset($sql) as $row)
	{
		if (isset($select_ary[$row['group_name']]))
		{
			$cnt = md5($row['group_name']) .'_cnt';
			$$cnt = @$$cnt + 1;
			$row['group_name'] = $row['group_name'] . ' ['. (int) $$cnt .']';
		}
		$select_ary[$row['group_name']] = $row['group_id'];
	}
	return ($select_ary) ? build_select($select_name, $select_ary, $selected_group) : '';
}


if (isset($_POST['change_rule'])) {
	$rule_change_list = get_var('rule_change_list', array(0));
  $rule_user_rating_list = get_var('rule_user_rating_list', array(0));
  $rule_user_age_list = get_var('rule_user_age_list', array(0));
  $rule_user_group_list = get_var('rule_user_group_list', array(0));
  $rule_invites_count_list = get_var('rule_invites_count_list', array(0));
  $rules = array();
  for ($i = 0; $i < sizeof($rule_change_list); $i++) {
    $rules['_' . $rule_change_list[$i]]['user_rating'] = intval($rule_user_rating_list[$i]);
    $rules['_' . $rule_change_list[$i]]['user_age'] = intval($rule_user_age_list[$i]);
    $rules['_' . $rule_change_list[$i]]['user_group'] = intval($rule_user_group_list[$i]);
    $rules['_' . $rule_change_list[$i]]['invites_count'] = intval($rule_invites_count_list[$i]);
  }
  $sql = 'SELECT * FROM `invite_rules` ORDER BY rule_id';
  if (!($result = $db->sql_query($sql))) message_die(GENERAL_ERROR, '      ', '', __LINE__, __FILE__, $sql);
  $num_rows = $db->sql_numrows($result);
  $rule_row = $db->sql_fetchrowset($result);
  $db->sql_freeresult($result);
  if ($num_rows > 0) {
    for ($i = 0; $i < sizeof($rule_row); $i++) {
      if (intval($rule_row[$i]['user_rating']) != intval($rules['_'.$rule_row[$i]['rule_id']]['user_rating']) || intval($rule_row[$i]['user_age']) != intval($rules['_'.$rule_row[$i]['rule_id']]['user_age']) || intval($rule_row[$i]['user_group']) != intval($rules['_'.$rule_row[$i]['rule_id']]['user_group']) || intval($rule_row[$i]['invites_count']) != intval($rules['_'.$rule_row[$i]['rule_id']]['invites_count'])) {
        $sql_ary = array(
          'user_rating'   => (int) $rules['_'.$rule_row[$i]['rule_id']]['user_rating'],
          'user_age'    => (int) $rules['_'.$rule_row[$i]['rule_id']]['user_age'],
          'user_group'    => (int) $rules['_'.$rule_row[$i]['rule_id']]['user_group'],
          'invites_count'   => (int) $rules['_'.$rule_row[$i]['rule_id']]['invites_count'],
        );
        $sql = 'UPDATE `invite_rules` SET '.attach_mod_sql_build_array('UPDATE', $sql_ary).' WHERE `rule_id` = '.(int)$rule_row[$i]['rule_id'];
        if (!$db->sql_query($sql)) message_die(GENERAL_ERROR, '   ', '', __LINE__, __FILE__, $sql);
      }
    }
  }
  
  // 
  $rule_id_list = get_var('rule_id_list', array(0));
  $rule_id_sql = implode(', ', $rule_id_list);
  if ($rule_id_sql != '') {
		$sql = 'DELETE FROM `invite_rules` WHERE rule_id IN ('.$rule_id_sql.')';
		if(!$result = $db->sql_query($sql)) message_die(GENERAL_ERROR, '   ', '', __LINE__, __FILE__, $sql);
	}
}

if (isset($_POST['add_rule'])) {
	$rule_user_rating = get_var('add_rule_user_rating', '');
  $rule_user_age = get_var('add_rule_user_age', '');
  $rule_user_group = $_POST['add_rule_user_group']; //get_var('add_rule_user_group', '');
  $rule_invites_count = get_var('add_rule_invites_count', '');
  $sql_ary = array(
    'user_rating'   => (int) $rule_user_rating,
    'user_age'    => (int) $rule_user_age,
    'user_group'    => (int) $rule_user_group,
    'invites_count'   => (int) $rule_invites_count
  );
  $sql = 'INSERT INTO `invite_rules` '.attach_mod_sql_build_array('INSERT', $sql_ary);
  if (!$db->sql_query($sql)) message_die(GENERAL_ERROR, '   ', '', __LINE__, __FILE__, $sql);
}

switch ($mode) {
	
	case 'rules':
		$template->assign_vars(array(
	    'TPL_INVITES_RULES'   => true,
	    'TPL_INVITES_HISTORY' => false,
	    'S_ADD_GROUP_SELECT'  => get_myselect('add_rule_user_group', '0'),
	    'S_RULES_ACTION'      => append_sid("admin_invites.$phpEx?mode=rules"))
	  );
	  $sql = 'SELECT * FROM `invite_rules` ORDER BY `invites_count`';
	  if (!($result = $db->sql_query($sql))) message_die(GENERAL_ERROR, '      ', '', __LINE__, __FILE__, $sql);
	  $rule_row = $db->sql_fetchrowset($result);
		$num_rule_row = $db->sql_numrows($result);
		$db->sql_freeresult($result);
		if ($num_rule_row > 0) {
			$rule_row = sort_multi_array($rule_row, 'invites_count', 'ASC');
			for ($i = 0; $i < $num_rule_row; $i++) {
				$template->assign_block_vars('rule_row', array(
					'RULE_ID'            => $rule_row[$i]['rule_id'],
					'USER_RATING'        => $rule_row[$i]['user_rating'],
					'USER_AGE'           => $rule_row[$i]['user_age'],
					'USER_GROUP'         => $rule_row[$i]['user_group'],
					'S_GROUP_SELECT'     => get_myselect('rule_user_group_list[]', $rule_row[$i]['user_group']),
					'INVITES_COUNT'      => $rule_row[$i]['invites_count'])
				);
			}
		}
	break;
	
	case 'history':
		$template->assign_vars(array(
	    'TPL_INVITES_RULES' => false,
	    'TPL_INVITES_HISTORY' => true)
	  );
	  $sql = 'SELECT * FROM `invites` ORDER BY `generation_date` DESC';
	  if (!($result = $db->sql_query($sql))) message_die(GENERAL_ERROR, '    ', '', __LINE__, __FILE__, $sql);
	  $invite_row = $db->sql_fetchrowset($result);
	  $num_invite_row = $db->sql_numrows($result);
	  $db->sql_freeresult($result);
	  if ($num_invite_row > 0) {
	    for ($i = 0; $i < $num_invite_row; $i++) {
	    	$user_data = get_userdata($invite_row[$i]['user_id']);
	      $new_user_data = get_userdata($invite_row[$i]['new_user_id']);
	      $template->assign_block_vars('invite_row', array(
	        'USER' => '<a href="http://'.$bb_cfg['server_name'].$bb_cfg['script_path'].'profile.php?mode=viewprofile&u='.$invite_row[$i]['user_id'].'" target="_blank">'.$user_data['username'].'</a>',
	        'GENERATION_DATE' => date('d.m.Y H:i', $invite_row[$i]['generation_date']),
	        'INVITE_CODE' => $invite_row[$i]['invite_code'],
	        'ACTIVE' => ($invite_row[$i]['active'] == '1') ? '' : '',
	        'NEW_USER' => ($invite_row[$i]['active'] == '1') ? '-' : '<a href="http://'.$bb_cfg['server_name'].$bb_cfg['script_path'].'profile.php?mode=viewprofile&u='.$invite_row[$i]['new_user_id'].'" target="_blank">'.$new_user_data['username'].'</a>',
	        'ACTIVATION_DATE' => ($invite_row[$i]['active'] == '1') ? '-' : date('d.m.Y H:i', $invite_row[$i]['activation_date']))
	      );
	    }
	  }
	break;

}

print_page('admin_invites.tpl', 'admin');

?>