<?php
define('IN_PHPBB', true);
define('BB_ROOT', './');
$phpEx = substr(strrchr(__FILE__, '.'), 1);
require(BB_ROOT . "common.$phpEx");
require_once(INC_DIR .'functions_admin.'. PHP_EXT);



// Obtain initial vars
$forum_id = (int) @$_REQUEST['f'];
$topic_id = (int) @$_REQUEST['t'];


	$sql = "
		SELECT
			f.forum_id, f.forum_name, f.forum_topics, f.self_moderated,
			t.topic_first_post_id, t.topic_poster
		FROM ". TOPICS_TABLE ." t, ". FORUMS_TABLE ." f
		WHERE t.topic_id = $topic_id
			AND f.forum_id = t.forum_id
		LIMIT 1
	";

	if (!$topic_row = $db->fetch_row($sql))
	{
		message_die(GENERAL_MESSAGE, 'Topic_post_not_exist');
	}

	$forum_id = $topic_row['forum_id'];
	$forum_name = $topic_row['forum_name'];
	$forum_topics = (!$topic_row['forum_topics']) ? 1 : $topic_row['forum_topics'];



// Start session management
$user->session_start(array('req_login' => true));

// Check if user did or did not confirm. If they did not, forward them to the last page they were on
if (isset($_POST['cancel']) || IS_GUEST)
{
	$redirect = "index.$phpEx";

	if ($topic_id || $forum_id)
	{
		$redirect = ($topic_id) ? TOPIC_URL . $topic_id : FORUM_URL . $forum_id;
	}
	redirect($redirect);
}

// Start auth check
$is_auth = auth(AUTH_ALL, $forum_id, $userdata);
$is_moderator = (IS_MOD || IS_ADMIN);



// Exit if user not authorized
if (!$is_moderator)
{
	message_die(GENERAL_MESSAGE, $lang['Not_Moderator'], $lang['Not_Authorised']);
}



// GET's
$mode = (string) @$_REQUEST['mode'];
$u_id= (string) @$_REQUEST['u'];
$user_id = $userdata['user_id'];





if ($mode == 'ro')
{

    $user_readonly = "1";
    $sql = "UPDATE " . USERS_TABLE . " SET user_readonly = $user_readonly WHERE user_id = $u_id";
    $db->sql_query($sql) or message_die(GENERAL_MESSAGE, 'Error updating user warnings', '', __LINE__, __FILE__, $sql);

    $message = '<center>   </center><br />' . sprintf($lang['Click_return_topic'], '<a href="javascript:history.go(-1)">', '</a>');
    message_die(GENERAL_MESSAGE, $message);
}
elseif ($mode == 'unro')
{

    $user_readonly = "0";
    $sql = "UPDATE " . USERS_TABLE . " SET user_readonly = $user_readonly WHERE user_id = $u_id";
    $db->sql_query($sql) or message_die(GENERAL_MESSAGE, 'Error updating user warnings', '', __LINE__, __FILE__, $sql);

    $message = '<center>   </center><br />' . sprintf($lang['Click_return_topic'], '<a href="javascript:history.go(-1)">', '</a>');
    message_die(GENERAL_MESSAGE, $message);

}
else
{
    $message = '<center>Access denied!</center><br /><a href="javascript:history.go(-1)"> </a>';
    message_die(GENERAL_MESSAGE, $message);
}


?>
